/*
  Zmienia strukture pliku enums.def. 
  Zmiany sa zapisywane do pliku enums.id

  Autor: Miroslaw Moscicki 13.10.1999 ver. 0.1

*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "def2id.h"

/*  enumsdef2enumsid() reads file enums.def 
                       and change it to file enum.id
	return 1 if success 
		   0 if failed
*/

int enumsdef2enumsid(char *nazwa1,char *nazwa2)
{FILE *def,*id;
 int newLine;
 char ch;
 char nr[10];
 int i,j;
 int leksem;
 int position;
 int endLoop;
 int nr_type;
 int firstLeksem;
 int count=0;
 struct sdef2id *first,*last,*last2;
 
 last=NULL;
 first=NULL;
 last2=NULL;
 //read file enums.def
 newLine=1;
 firstLeksem=1;
 i=0;
 def=fopen(nazwa1,"r");
 if(def==NULL)
	 return 0;
 //assert(def!=NULL);
 endLoop=0;	
 while( endLoop==0 ) 
   {if ((ch=getc(def)) == EOF ) 
      endLoop=1;
    if (newLine==1)
		{//first is nr_type
		 if (ch=='\t')
			{newLine=0;
			 position=0;
			 nr[i]=0;
			 i=0;
			 nr_type=atoi(nr);          
			 //Nr_Type OK
			}
		else
			{nr[i]=ch;
			 i++;
			}
		}
	else
		{//it's leksem
		 if ( (ch=='\t') || (ch=='\n') || (ch==EOF))
			{nr[i]=0;
			 i=0;
			 leksem=atoi(nr);
			 if (firstLeksem==1)
				{first=(struct sdef2id *)malloc(sizeof(struct sdef2id));
				 assert(first!=NULL);
				 first->leksem=leksem;
				 first->nr_type=nr_type;
				 first->position=position;
				 first->ok=0;
				 first->next=NULL;
				 last=first;
				 firstLeksem=0;
				 count=1;
				}
			 else
				{last->next=(struct sdef2id *)malloc(sizeof(struct sdef2id));
				 assert(last->next!=NULL);
				 last=last->next;
				 last->leksem=leksem;
				 last->nr_type=nr_type;
				 last->position=position;
				 last->ok=0;
				 last->next=NULL;
				 count++;
				}
			 //leksem OK
			 position++;
			 if (ch=='\n')
				{newLine=1;
				 continue;
				}
			}
		else
			{nr[i]=ch;
			 i++;
			}
		}
    
   }

 fclose(def);
 
  
 //write file enums.id
 id=fopen(nazwa2,"w");
 assert(id!=NULL);
 last=first;
 for (i=0; i<count; i++)
	{if (last->ok==0)
		{//zapisz last.nr_type
		 //oraz po tabulacji last.leksem
		 fprintf(id,"%d\t%d\t%d",last->leksem,last->nr_type,last->position);
		 last->ok=1;
		 last2=last->next;
		 for (j=0; j<count; j++)
			{if (last2==NULL)
				break;
			 if (last2->leksem==last->leksem)
				{//zapisz tabulacje oraz last2.leksem
				 fprintf(id,"\t%d\t%d",last2->nr_type,last2->position);
				 last2->ok=1;
				}
			 last2=last2->next;
			}
		 //zapisz enter
		 fprintf(id,"\n");
		}
	 last=last->next;
	}
 fclose(id);

 last=first;
 for (i=0; i<count; i++)
	{last2=last;
	 last=last->next;
	 free (last2);
	}


 return(1);
}

