#ifndef __STACK__H__
#define __STACK__H__

typedef struct stack
{
	int val;
	char str[256];
	struct stack *prev;
} stack_element;

typedef stack_element * stack_id;

int stack_push( stack_id *, int, char *);
int stack_pop( stack_id *, int *, char *);

#define OK                      0
#define ALLOCATION_ERROR        1
#define EMPTY_STACK             2

#endif
