#ifndef __VHDL_TAB__H__
#define __VHDL_TAB__H__

#define	tok_ACCESS	258
#define	tok_AFTER	259
#define	tok_ALIAS	260
#define	tok_ALL	261
#define	tok_AND	262
#define	tok_ARCHITECTURE	263
#define	tok_ARRAY	264
#define	tok_ASSERT	265
#define	tok_ATTRIBUTE	266
#define	tok_BEGIN	267
#define	tok_BLOCK	268
#define	tok_BODY	269
#define	tok_BUFFER	270
#define	tok_BUS	271
#define	tok_CASE	272
#define	tok_COMPONENT	273
#define	tok_CONFIGURATION	274
#define	tok_CONSTANT	275
#define	tok_DISCONNECT	276
#define	tok_DOWNTO	277
#define	tok_ELSE	278
#define	tok_ELSIF	279
#define	tok_END	280
#define	tok_ENTITY	281
#define	tok_EXIT	282
#define	tok_FILE	283
#define	tok_FOR	284
#define	tok_FUNCTION	285
#define	tok_GENERATE	286
#define	tok_GENERIC	287
#define	tok_GROUP	288
#define	tok_GUARDED	289
#define	tok_IF	290
#define	tok_IMPURE	291
#define	tok_IN	292
#define	tok_INERTIAL	293
#define	tok_INOUT	294
#define	tok_IS	295
#define	tok_LABEL	296
#define	tok_LIBRARY	297
#define	tok_LINKAGE	298
#define	tok_LITERAL	299
#define	tok_LOOP	300
#define	tok_MAP	301
#define	tok_NAND	302
#define	tok_NEW	303
#define	tok_NEXT	304
#define	tok_NOR	305
#define	tok_NULL	306
#define	tok_OF	307
#define	tok_ON	308
#define	tok_OPEN	309
#define	tok_OR	310
#define	tok_OTHERS	311
#define	tok_OUT	312
#define	tok_PACKAGE	313
#define	tok_PORT	314
#define	tok_POSTPONED	315
#define	tok_PROCEDURE	316
#define	tok_PROCESS	317
#define	tok_PURE	318
#define	tok_RANGE	319
#define	tok_RECORD	320
#define	tok_REGISTER	321
#define	tok_REJECT	322
#define	tok_REPORT	323
#define	tok_RETURN	324
#define	tok_ROL	325
#define	tok_ROR	326
#define	tok_SELECT	327
#define	tok_SEVERITY	328
#define	tok_SHARED	329
#define	tok_SIGNAL	330
#define	tok_SLA	331
#define	tok_SLL	332
#define	tok_SRA	333
#define	tok_SRL	334
#define	tok_SUBTYPE	335
#define	tok_THEN	336
#define	tok_TO	337
#define	tok_TRANSPORT	338
#define	tok_TYPE	339
#define	tok_UNAFFECTED	340
#define	tok_UNITS	341
#define	tok_UNTIL	342
#define	tok_USE	343
#define	tok_VARIABLE	344
#define	tok_WAIT	345
#define	tok_WHEN	346
#define	tok_WHILE	347
#define	tok_WITH	348
#define	tok_XNOR	349
#define	tok_XOR	350
#define	tok_EQSym	351
#define	tok_NESym	352
#define	tok_LTSym	353
#define	tok_LESym	354
#define	tok_GTSym	355
#define	tok_GESym	356
#define	tok_DoubleStar	357
#define	tok_ABS	358
#define	tok_NOT	359
#define	MAX_PRECEDENCE	360
#define	tok_Plus	361
#define	tok_Minus	362
#define	tok_Ampersand	363
#define	MED_PRECEDENCE	364
#define	tok_Star	365
#define	tok_Slash	366
#define	tok_MOD	367
#define	tok_REM	368
#define	tok_Apostrophe	369
#define	tok_LeftParen	370
#define	tok_RightParen	371
#define	tok_Comma	372
#define	tok_VarAsgn	373
#define	tok_Colon	374
#define	tok_Semicolon	375
#define	tok_Arrow	376
#define	tok_Box	377
#define	tok_Bar	378
#define	tok_Dot	379
#define	tok_Identifier	380
#define	tok_AbstractLit	381
#define	tok_CharacterLit	382
#define	tok_StringLit	383
#define	tok_BitStringLit	384

struct yystype
{
	int line;
	int toknum;
	int semval;
	char tokstr[1024];
};
typedef struct yystype YYSTYPE;

typedef struct
{
	int Class;
	int mode;
	int type_toknum;
}DECL_STATUS;

int yylex(void);


#endif