#include <string.h>
#include <stdlib.h>

#include "tstst.h"

extern struct PBGLOBAL *SemGlobal;

int AddToProcessList(char *prname)
{
	int i, CorrectName=0, EndOfName=0, NameLen, WasModified=0;
	NameLen=strlen(prname);
	if(SemGlobal->ListOfPrcs==NULL)
	{
		SemGlobal->ListOfPrcs=(PRCSLIST*)malloc(sizeof(PRCSLIST));
		SemGlobal->ProcessCnt=0;
	}
	else
	{
		SemGlobal->ListOfPrcs=(PRCSLIST*)realloc((PRCSLIST*)SemGlobal->ListOfPrcs, sizeof(PRCSLIST)*(SemGlobal->ProcessCnt+1));
	}
	while(!CorrectName)
	{
		for(i=0 ; i<SemGlobal->ProcessCnt ; i++)
		{
			if(!stricmp(SemGlobal->ListOfPrcs[i].name, prname))
				break;
		}
		if(i==SemGlobal->ProcessCnt)
		{
			CorrectName=1;
			continue;
		}
		sprintf(prname+NameLen, "%d", EndOfName);
		EndOfName++;
		WasModified=1;
	}
	if(WasModified)
		WriteLastLexemId(prname);
	SemGlobal->ListOfPrcs[SemGlobal->ProcessCnt].name=strdup(prname);
	SemGlobal->ProcessCnt++;
	if(WasModified)
		return SemGlobal->LastLexemId+199;
	return 0;
}//AddToProcessList

int AddToBlockList(char *blname)
{
	int i, CorrectName=0, EndOfName=0, NameLen, WasModified=0;
	NameLen=strlen(blname);
	if(SemGlobal->ListOfBlocks==NULL)
	{
		SemGlobal->ListOfBlocks=(PRCSLIST*)malloc(sizeof(PRCSLIST));
		SemGlobal->BlockCnt=0;
	}
	else
	{
		SemGlobal->ListOfBlocks=(PRCSLIST*)realloc((PRCSLIST*)SemGlobal->ListOfBlocks, sizeof(PRCSLIST)*(SemGlobal->BlockCnt+1));
	}
	while(!CorrectName)
	{
		for(i=0 ; i<SemGlobal->BlockCnt ; i++)
		{
			if(!stricmp(SemGlobal->ListOfBlocks[i].name, blname))
				break;
		}
		if(i==SemGlobal->BlockCnt)
		{
			CorrectName=1;
			continue;
		}
		sprintf(blname+NameLen, "%d", EndOfName);
		EndOfName++;
		WasModified=1;
	}
	if(WasModified)
		WriteLastLexemId(blname);
	SemGlobal->ListOfBlocks[SemGlobal->BlockCnt].name=strdup(blname);
	SemGlobal->BlockCnt++;
	if(WasModified)
		return SemGlobal->LastLexemId+199;
	return 0;
}//AddToBlockList
