#ifndef __SEMVAL__H__
#define __SEMVAL__H__

#define MIN_VHDL_INT -2147483647
#define MAX_VHDL_INT  2147483647
#define MIN_VHDL_NATURAL 0
#define MAX_VHDL_NATURAL MAX_VHDL_INT
#define MIN_VHDL_POSITIVE 1
#define MAX_VHDL_POSITIVE MAX_VHDL_INT

FILE *ParseAllEntities(void);
int GetTypeString(char *);
int NewGetTypeString(char *);
int ConvertVarToTypeDecl(char *);
void IntegerTypeInformation(char *);
int ArrayTypeInformation(int, char *, char *);
int FindTypeInformation(int, char *, char *);
int FindLexemInformation(int, char *);
int FindTypeString(int, char *, char *);
int FindTypeStringInPack(int, char *, char *);
int TryFindTypeStringInPack(int, char *, char *);
int FindArchitecture(int);
int ParseEntityPortList(char *, int);
int ParseParameterList(FILE *);
int ParseFunctionParameterList(FILE *);
int ParseProcedureParameterList(FILE *);
int ParseSubTypeDeclaration(void);
int ParseTypeDeclaration(void);
int ParseConstantDeclaration(FILE *);
int AnonymousTypeGeneration(void);
int HowManyBits(unsigned);
int HowManyBitsInt(int, int);
void WritePredefinedTypes(char *);
int ProcessTranslation(int, int);
int analysePPF(FILE*,int, int);
int ParseDeclarativePart(FILE *);
int is_ge_zero(int);

#endif