#include <stdlib.h>
#include <string.h>
#include "stack.h"

int stack_push( stack_id *stack, int val, char *str)
  {
  stack_element *new_element=(stack_element*)malloc(sizeof(stack_element));
  if( !new_element)
    return ALLOCATION_ERROR;
  new_element->prev=(*stack);
  new_element->val=val;
  strcpy( new_element->str, str);
  *stack=new_element;
  return OK;
  }

int stack_pop( stack_id *stack, int *val, char *str)
  {
  stack_element *old_top=(*stack);
  if( !(*stack))
    return EMPTY_STACK;
  *val=(*stack)->val;
  strcpy( str, (const char *)(*stack)->str);
  *stack=(*stack)->prev;
  free(old_top);
  return OK;
  }
